#ifndef __SMARTT_CLIENT_H
#define __SMARTT_CLIENT_H


struct s_event_config
{
    int             event_enable[NO_OF_EVENTS];
    double          stat_counter;
    unsigned int    samples;
};

struct s_channel_config
{
    char            host_ip[16];
    unsigned int    port_no;
};

struct s_client_handler
{
    char                                msg_id[64];
    unsigned int                        pid;
    struct          s_event_config      event_config;
    struct          s_channel_config    local_client;
};

struct s_report_manager
{
    unsigned int    report_counter;
    unsigned int    events_enabled;
    double          stat_counter;
    unsigned int    total_samples;
};

struct s_sys_info
{
    unsigned int           pid;
    unsigned long int      cpu_cycles;
    unsigned long int      instructions;                      
    unsigned long int      bus_cycles;                                
    unsigned long int      cache_misses;                              
    unsigned long int      branches;
    unsigned long int      time_stamp;
};

struct s_mem_info {
    unsigned long int      main_total;
    unsigned long int      main_used;                      
    unsigned long int      main_free;                                
    unsigned long int      main_buffers;
    unsigned long int      main_cached;                              
    unsigned long int      swap_total;
    unsigned long int      swap_used;                      
    unsigned long int      swap_free;                                
};

struct s_player_info
{ 
    unsigned int            pid;
    unsigned int            rate;     
    unsigned int            width ;   
    unsigned int            height;   
    double                  curfps;   
    double                  dps;      
    double                  avgfps;   
    unsigned long int       dropped;  
    unsigned long int       renderred;
    char vcodec[64];
    char acodec[64];
};

struct s_system_data
{
    struct s_sys_info          sys_info;
    struct s_mem_info          mem_info;
    struct s_player_info       player_info;
};

void SMARTTclient_Run();
void SMARTTclient_ShowDisplay();
void SMARTTclient_PrintHeaders();
void SMARTTclient_PrintStats(unsigned int);
void SMARTTclient_GenerateReport();
int SMARTTclient_FilterSystemEvents();
void SMARTTclient_Init();


#endif /* __SMARTT-CLIENT_H */


