
#ifndef __SMARTT_USERCONFIG_H
#define __SMARTT_USERCONFIG_H


#define NO_OF_EVENTS 6

typedef unsigned int    t_pid;
typedef double          t_stat_counter;
typedef unsigned int    t_sample_count;
typedef unsigned int    t_watermark_level;

struct s_event_handler
{
    const char          *event_name;
    int                 event_enable;
    t_stat_counter      stat_counter;
    t_sample_count      sample_count;
    t_watermark_level   watermark_level;
};

const char *sys_events[] = { 
    "CPU-CYCLES     ",
    "INSTRUCTIONS   ", 
    "BUS-CYCLES     ",
    "CACHE-MISSES   ",
    "BRANCHES       ",
    "MEM-USAGE      "
};


typedef enum
{
    CPU_CYCLES      = 0,
    INSTRUCTIONS    = 1,
    BUS_CYCLES      = 2,
    CACHE_MISSES    = 3,
    BRANCHES        = 4,
    MEM_USAGE       = 5
}t_event_id;


typedef enum
{
    EVENT_DISABLE   = 0,
    EVENT_ENABLE    = 1
}t_event_enable;



int  SMARTTclient_SetUserConfig(char **conf_args);
void SMARTTclient_GetUserConfig();
int SMARTTclient_SaveUserConfig();
void SMARTTclient_RestoreUserConfig();
int  SMARTTclient_SetUserPid(char **conf_args);
void SMARTTclient_SetConfig(t_event_id, t_event_enable, t_stat_counter,
                                   t_sample_count, t_watermark_level );

#endif /*__SMARTT-USERCONFIG_H*/
