
/*
 * smartt-util.c
 *
 * Utility functions
*/

#include "smartt-utils.h"

void  smartt_util_exec(char *line)
{
    char *argv[64];                                 /* the command line argument      */
    int i = 0;

    if (strcmp(line,"clear")==0)
    *(argv + i++) = "clear";
    *(argv + i)   = '\0';

    smartt_util_execute(argv);
}

void  smartt_util_parse(char *line, char **argv)
{
        while (*line != '\0') {       /* if not the end of line ....... */ 
          while (*line == ' ' || *line == '\t' || *line == '\n')
               *line++ = '\0';     /* replace white spaces with 0    */
          *argv++ = line;          /* save the argument position     */
          while (*line != '\0' && *line != ' ' && 
                 *line != '\t' && *line != '\n') 
               line++;             /* skip the argument until ...    */
     }
     *argv = '\0';                 /* mark the end of argument list  */
    
}

void  smartt_util_execute(char **argv)
{
     pid_t  pid;
     int    status;

     if ((pid = fork()) < 0) {     /* fork a child process           */
          printf("*** ERROR: forking child process failed\n");
          exit(1);
     }
     else if (pid == 0) {          /* for the child process:         */

         if (execvp(*argv, argv) < 0) {     /* execute the command  */
               printf("*** ERROR: exec failed\n");
               exit(1);
          }
     }
     else {                                  /* for the parent:      */
          while (wait(&status) != pid)       /* wait for completion  */
               ;
     }
}


