/* 
 * smartt-network-services.c
 *
 * Network Configuration
*/

#include "smartt-network-services.h"
#include "smartt-server-utils.h"

unsigned int addr_len;

int SMARTTserver_OpenSmarttClient_INPort()
{

    bool status;
    char param_type[64];
    unsigned int local_port;


    FILE *f1 = fopen("/etc/smartt/smartt-server.conf", "r");
    if (f1== NULL)
    {        
        fprintf(stderr, "[E] Cannot open  smart-server.conf in /etc/smartt/ \t\t: Error\n");
        exit(1);
    }

    fscanf(f1,"%s %d\n",param_type, &local_port);

    smartt_client_rx_sock_desc = socket(AF_INET,SOCK_DGRAM,0);
    if (smartt_client_rx_sock_desc == -1)
    {
        fprintf(stderr,"Error opening the connection\n");
        exit(1);
    }

    smartt_client_rx_server_addr.sin_family          =   AF_INET;
    smartt_client_rx_server_addr.sin_addr.s_addr     =   htonl(INADDR_ANY);
    smartt_client_rx_server_addr.sin_port            =   (local_port);

    status = bind(smartt_client_rx_sock_desc,(struct sockaddr *)&smartt_client_rx_server_addr, sizeof(smartt_client_rx_server_addr));
    if (status == -1)
    {
        fprintf(stderr, "Failed to bind the client\n");
        exit(1);
    }

    addr_len = sizeof(struct sockaddr);
    return(1);
}

int SMARTTserver_OpenSmarttClient_OUTPort(char* remote_host, unsigned int remote_port) 
{
    struct  hostent *hp;

    smartt_client_tx_sock_desc = socket(AF_INET,SOCK_DGRAM,0);
    if (smartt_client_tx_sock_desc == -1)
    {
        fprintf(stderr,"[E] Error opening Tx Server\t\t: Error\n");
        exit(1);
    }
    smartt_client_tx_server_addr.sin_family = AF_INET;
    smartt_client_tx_server_addr.sin_port  = remote_port;
    hp = gethostbyname(remote_host);
    bcopy (hp->h_addr,&(smartt_client_tx_server_addr.sin_addr),hp->h_length);
    return(1);
}

int SMARTTserver_OpenSmarttPerf_INPort()
{
    bool status;

    smartt_perf_rx_sock_desc = socket(AF_INET,SOCK_DGRAM,0);
    if (smartt_perf_rx_sock_desc == -1)
    {
        fprintf(stderr,"Error opening the connection\n");
        exit(1);
    }

    smartt_perf_rx_server_addr.sin_family       =   AF_INET;
    smartt_perf_rx_server_addr.sin_addr.s_addr  =   htonl(INADDR_ANY);
    smartt_perf_rx_server_addr.sin_port         =   (SMARTT_PERF_LOCAL_PORT);

    status = bind(smartt_perf_rx_sock_desc,(struct sockaddr *)&smartt_perf_rx_server_addr, sizeof(smartt_perf_rx_server_addr));
    if (status == -1)
    {
        fprintf(stderr, "Failed to bind the client\n");
        exit(1);
    }

    addr_len = sizeof(struct sockaddr);
    return(1);
}

int SMARTTserver_OpenSmarttTop_INPort()
{
    bool status;

    smartt_top_rx_sock_desc = socket(AF_INET,SOCK_DGRAM,0);
    if (smartt_top_rx_sock_desc == -1)
    {
        fprintf(stderr,"Error opening the connection\n");
        exit(1);
    }

    smartt_top_rx_server_addr.sin_family = AF_INET;
    smartt_top_rx_server_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    smartt_top_rx_server_addr.sin_port  = (SMARTT_TOP_LOCAL_PORT);

    status = bind(smartt_top_rx_sock_desc,(struct sockaddr *)&smartt_top_rx_server_addr, sizeof(smartt_top_rx_server_addr));
    if (status == -1)
    {
        fprintf(stderr, "Failed to bind the client\n");
        exit(1);
    }

    addr_len = sizeof(struct sockaddr);
    return(1);
}

int SMARTTserver_OpenSmarttPlayer_INPort()
{
    bool status;

    smartt_player_rx_sock_desc = socket(AF_INET,SOCK_DGRAM,0);
    if (smartt_player_rx_sock_desc == -1)
    {
        fprintf(stderr,"Error opening the connection\n");
        exit(1);
    }

    smartt_player_rx_server_addr.sin_family         =   AF_INET;
    smartt_player_rx_server_addr.sin_addr.s_addr    =   htonl(INADDR_ANY);
    smartt_player_rx_server_addr.sin_port           =   (SMARTT_PLAYER_LOCAL_PORT);

    status = bind(smartt_player_rx_sock_desc,(struct sockaddr *)&smartt_player_rx_server_addr, sizeof(smartt_player_rx_server_addr));
    if (status == -1)
    {
        fprintf(stderr, "Failed to bind the client\n");
        exit(1);
    }

    addr_len = sizeof(struct sockaddr);
    return(1);
}


