
#ifndef __SMARTT_SERVER_H
#define __SMARTT_SERVER_H
#define NO_OF_EVENTS 6

struct s_client_event_manager
{
    const char      *event_name;
    int             event_enable;
    double          data_counter;
    unsigned int    sample_count;
};

struct s_event_config
{
    int             event_enable[NO_OF_EVENTS];
    double          counter;
    unsigned int    samples;
};

struct s_channel_config
{
    char            host_ip[16];
    unsigned int    port_no;
};

struct s_remote_client_handler
{
    char                        msg_id[64];
    unsigned int                pid;
    struct  s_event_config      event_config;
    struct  s_channel_config    channel_config;
};

struct s_sys_info
{
    unsigned int           pid;
    unsigned long int      cpu_cycles;
    unsigned long int      instructions;                      
    unsigned long int      bus_cycles;                                
    unsigned long int      cache_misses;                              
    unsigned long int      branches;
    unsigned long int      time_stamp;
};

struct s_mem_info {
    unsigned long int      main_total;
    unsigned long int      main_used;                      
    unsigned long int      main_free;                                
    unsigned long int      main_buffers;
    unsigned long int      main_cached;                              
    unsigned long int      swap_total;
    unsigned long int      swap_used;                      
    unsigned long int      swap_free;                                
};

struct s_player_info
{ 
    unsigned int            pid;
    unsigned int            rate;     
    unsigned int            width ;   
    unsigned int            height;   
    double                  curfps;   
    double                  dps;      
    double                  avgfps;   
    unsigned long int       dropped;  
    unsigned long int       renderred;
    char vcodec[64];
    char acodec[64];
};

struct s_system_data
{
    struct s_sys_info          sys_info;
    struct s_mem_info          mem_info;
    struct s_player_info       player_info;
};

void SMARTTserver_Init();
int SMARTTserver_Start();
void SMARTTserver_Exec();
void SMARTTserver_Process();
void SMARTTserver_Capture();
void SMARTTserver_FillPerfArgs();
void SMARTTserver_Test();
void SMARTTserver_Exit();
int SMARTTserver_GetUserPid();

#endif /* __SMARTT_SERVER_H */
